//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3FBB88AC02AA.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3FBB88AC02AA.cm

//## begin module%3FBB88AC02AA.cp preserve=no
//## end module%3FBB88AC02AA.cp

//## Module: WmapRegion%3FBB88AC02AA; Package specification
//## Subsystem: XSModel::Model::MixFunction%3F74624902C0
//## Source file: /data/gordon/headas/Xspec/src/XSModel/Model/MixFunction/WmapRegion.h

#ifndef WMAPREGION_H
#define WMAPREGION_H 1

//## begin module%3FBB88AC02AA.additionalIncludes preserve=no
//## end module%3FBB88AC02AA.additionalIncludes

//## begin module%3FBB88AC02AA.includes preserve=yes
#include "xsTypes.h"
//## end module%3FBB88AC02AA.includes

// Error
#include <XSUtil/Error/Error.h>
//## begin module%3FBB88AC02AA.declarations preserve=no
//## end module%3FBB88AC02AA.declarations

//## begin module%3FBB88AC02AA.additionalDeclarations preserve=yes
namespace CCfits
{
   class FITS;
}
//## end module%3FBB88AC02AA.additionalDeclarations


//## begin WmapRegion%3FBB89E40133.preface preserve=yes
//## end WmapRegion%3FBB89E40133.preface

//## Class: WmapRegion%3FBB89E40133
//## Category: XSModel::Model::MixFunction%3F7461FF026E
//## Subsystem: XSModel::Model::MixFunction%3F74624902C0
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class WmapRegion 
{
  //## begin WmapRegion%3FBB89E40133.initialDeclarations preserve=yes
  //## end WmapRegion%3FBB89E40133.initialDeclarations

  public:
    //## Class: WmapRegionError%3FBB96A80036
    //## Category: XSModel::Model::MixFunction%3F7461FF026E
    //## Subsystem: XSModel::Model::MixFunction%3F74624902C0
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class WmapRegionError : public YellowAlert  //## Inherits: <unnamed>%3FBB96D2030F
    {
      public:
        //## Constructors (specified)
          //## Operation: WmapRegionError%3FBB972A00C8
          WmapRegionError (const string& msg);

      protected:
      private:
      private: //## implementation
    };

    //## Destructor (generated)
      virtual ~WmapRegion() = 0;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: lowerLeft%3FBB8DFA03D4
      std::pair<Real,Real> lowerLeft () const;

      //## Attribute: upperRight%3FBB8E11012E
      std::pair<Real,Real> upperRight () const;

      //## Attribute: nx%3FBB8FC301A0
      int nx () const;

      //## Attribute: ny%3FBB8FCB0092
      int ny () const;

      //## Attribute: wmap%3FBB90690241
      const std::valarray<int>& wmap () const;

      //## Attribute: wmrbn%3FBB91550374
      int wmrbn () const;

      //## Attribute: file%3FBBB384019C
      const CCfits::FITS* file () const;

      //## Attribute: version%403626D9002C
      Real version () const;

      //## Attribute: wmapPos%42EA3A5B02EB
      const IntegerArray& wmapPos () const;

      //## Attribute: isPixOn%42EA4B1803E3
      const std::valarray<bool>& isPixOn () const;

  public:
    // Additional Public Declarations
      //## begin WmapRegion%3FBB89E40133.public preserve=yes
      //## end WmapRegion%3FBB89E40133.public

  protected:
    //## Constructors (generated)
      WmapRegion();


    //## Other Operations (specified)
      //## Operation: readCommonKeys%3FBB924702CC
      void readCommonKeys ();

      //## Operation: readWmap%3FBB946A0366
      virtual void readWmap (int* nullVal = 0);

      //## Operation: readSpecificKeys%3FBB956A0386
      virtual void readSpecificKeys () = 0;

      //## Operation: read%3FBCCAF70004
      void read (const string& fileName, int* nullVal = 0);

    // Additional Protected Declarations
      //## begin WmapRegion%3FBB89E40133.protected preserve=yes
      //## end WmapRegion%3FBB89E40133.protected

  private:

    //## Other Operations (specified)
      //## Operation: getVersion%3FBBB45E034D
      Real getVersion ();

      //## Operation: getWmrbn%3FBBB47E01E4
      void getWmrbn ();

      //## Operation: getCorners%3FBBB49A007D
      void getCorners ();

    // Additional Private Declarations
      //## begin WmapRegion%3FBB89E40133.private preserve=yes
      //## end WmapRegion%3FBB89E40133.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin WmapRegion::lowerLeft%3FBB8DFA03D4.attr preserve=no  public: std::pair<Real,Real> {U} 
      std::pair<Real,Real> m_lowerLeft;
      //## end WmapRegion::lowerLeft%3FBB8DFA03D4.attr

      //## begin WmapRegion::upperRight%3FBB8E11012E.attr preserve=no  public: std::pair<Real,Real> {U} 
      std::pair<Real,Real> m_upperRight;
      //## end WmapRegion::upperRight%3FBB8E11012E.attr

      //## begin WmapRegion::nx%3FBB8FC301A0.attr preserve=no  public: int {U} 
      int m_nx;
      //## end WmapRegion::nx%3FBB8FC301A0.attr

      //## begin WmapRegion::ny%3FBB8FCB0092.attr preserve=no  public: int {U} 
      int m_ny;
      //## end WmapRegion::ny%3FBB8FCB0092.attr

      //## begin WmapRegion::wmap%3FBB90690241.attr preserve=no  public: std::valarray<int> {U} 
      std::valarray<int> m_wmap;
      //## end WmapRegion::wmap%3FBB90690241.attr

      //## begin WmapRegion::wmrbn%3FBB91550374.attr preserve=no  public: int {U} 
      int m_wmrbn;
      //## end WmapRegion::wmrbn%3FBB91550374.attr

      //## begin WmapRegion::file%3FBBB384019C.attr preserve=no  public: CCfits::FITS* {U} 
      CCfits::FITS* m_file;
      //## end WmapRegion::file%3FBBB384019C.attr

      //## Attribute: refBinKeys%3FBBC61502E1
      //## begin WmapRegion::refBinKeys%3FBBC61502E1.attr preserve=no  private: std::pair<string,string> {U} 
      std::pair<string,string> m_refBinKeys;
      //## end WmapRegion::refBinKeys%3FBBC61502E1.attr

      //## Attribute: wmrbnKey%3FBBC653019C
      //## begin WmapRegion::wmrbnKey%3FBBC653019C.attr preserve=no  private: string {U} 
      string m_wmrbnKey;
      //## end WmapRegion::wmrbnKey%3FBBC653019C.attr

      //## begin WmapRegion::version%403626D9002C.attr preserve=no  public: Real {U} 
      Real m_version;
      //## end WmapRegion::version%403626D9002C.attr

      //## begin WmapRegion::wmapPos%42EA3A5B02EB.attr preserve=no  public: IntegerArray {U} 
      IntegerArray m_wmapPos;
      //## end WmapRegion::wmapPos%42EA3A5B02EB.attr

      //## begin WmapRegion::isPixOn%42EA4B1803E3.attr preserve=no  public: std::valarray<bool> {U} 
      std::valarray<bool> m_isPixOn;
      //## end WmapRegion::isPixOn%42EA4B1803E3.attr

    // Additional Implementation Declarations
      //## begin WmapRegion%3FBB89E40133.implementation preserve=yes
      //## end WmapRegion%3FBB89E40133.implementation

};

//## begin WmapRegion%3FBB89E40133.postscript preserve=yes
//## end WmapRegion%3FBB89E40133.postscript

// Class WmapRegion::WmapRegionError 

// Class WmapRegion 

//## Get and Set Operations for Class Attributes (inline)

inline std::pair<Real,Real> WmapRegion::lowerLeft () const
{
  //## begin WmapRegion::lowerLeft%3FBB8DFA03D4.get preserve=no
  return m_lowerLeft;
  //## end WmapRegion::lowerLeft%3FBB8DFA03D4.get
}

inline std::pair<Real,Real> WmapRegion::upperRight () const
{
  //## begin WmapRegion::upperRight%3FBB8E11012E.get preserve=no
  return m_upperRight;
  //## end WmapRegion::upperRight%3FBB8E11012E.get
}

inline int WmapRegion::nx () const
{
  //## begin WmapRegion::nx%3FBB8FC301A0.get preserve=no
  return m_nx;
  //## end WmapRegion::nx%3FBB8FC301A0.get
}

inline int WmapRegion::ny () const
{
  //## begin WmapRegion::ny%3FBB8FCB0092.get preserve=no
  return m_ny;
  //## end WmapRegion::ny%3FBB8FCB0092.get
}

inline const std::valarray<int>& WmapRegion::wmap () const
{
  //## begin WmapRegion::wmap%3FBB90690241.get preserve=no
  return m_wmap;
  //## end WmapRegion::wmap%3FBB90690241.get
}

inline int WmapRegion::wmrbn () const
{
  //## begin WmapRegion::wmrbn%3FBB91550374.get preserve=no
  return m_wmrbn;
  //## end WmapRegion::wmrbn%3FBB91550374.get
}

inline const CCfits::FITS* WmapRegion::file () const
{
  //## begin WmapRegion::file%3FBBB384019C.get preserve=no
  return m_file;
  //## end WmapRegion::file%3FBBB384019C.get
}

inline Real WmapRegion::version () const
{
  //## begin WmapRegion::version%403626D9002C.get preserve=no
  return m_version;
  //## end WmapRegion::version%403626D9002C.get
}

inline const IntegerArray& WmapRegion::wmapPos () const
{
  //## begin WmapRegion::wmapPos%42EA3A5B02EB.get preserve=no
  return m_wmapPos;
  //## end WmapRegion::wmapPos%42EA3A5B02EB.get
}

inline const std::valarray<bool>& WmapRegion::isPixOn () const
{
  //## begin WmapRegion::isPixOn%42EA4B1803E3.get preserve=no
  return m_isPixOn;
  //## end WmapRegion::isPixOn%42EA4B1803E3.get
}

//## begin module%3FBB88AC02AA.epilog preserve=yes
//## end module%3FBB88AC02AA.epilog


#endif
